SFML - Simple and Fast Multimedia Library

SFML 2.5.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Protected Member Functions | List of all members
sf::RenderTarget Class Referenceabstract
Graphics module

Base class for all render targets (window, texture, ...) More...

`#include <RenderTarget.hpp>`

Inheritance diagram for sf::RenderTarget:

## Public Member Functions
virtual | ~RenderTarget ()
| Destructor. More...
void | clear (const Color &color=Color(0, 0, 0, 255))
| Clear the entire target with a single color. More...
void | setView (const View &view)
| Change the current active view. More...
const View & | getView () const
| Get the view currently in use in the render target. More...
const View & | getDefaultView () const
| Get the default view of the render target. More...
IntRect | getViewport (const View &view) const
| Get the viewport of a view, applied to this render target. More...
Vector2f | mapPixelToCoords (const Vector2i &point) const
| Convert a point from target coordinates to world coordinates, using the current view. More...
Vector2f | mapPixelToCoords (const Vector2i &point, const View &view) const
| Convert a point from target coordinates to world coordinates. More...
Vector2i | mapCoordsToPixel (const Vector2f &point) const
| Convert a point from world coordinates to target coordinates, using the current view. More...
Vector2i | mapCoordsToPixel (const Vector2f &point, const View &view) const
| Convert a point from world coordinates to target coordinates. More...
void | draw (const Drawable &drawable, const RenderStates &states=RenderStates::Default)
| Draw a drawable object to the render target. More...
void | draw (const Vertex *vertices, std::size_t vertexCount, PrimitiveType type, const RenderStates &states=RenderStates::Default)
| Draw primitives defined by an array of vertices. More...
void | draw (const VertexBuffer &vertexBuffer, const RenderStates &states=RenderStates::Default)
| Draw primitives defined by a vertex buffer. More...
void | draw (const VertexBuffer &vertexBuffer, std::size_t firstVertex, std::size_t vertexCount, const RenderStates &states=RenderStates::Default)
| Draw primitives defined by a vertex buffer. More...
virtual Vector2u | getSize () const =0
| Return the size of the rendering region of the target. More...
virtual bool | setActive (bool active=true)
| Activate or deactivate the render target for rendering. More...
void | pushGLStates ()
| Save the current OpenGL render states and matrices. More...
void | popGLStates ()
| Restore the previously saved OpenGL render states and matrices. More...
void | resetGLStates ()
| Reset the internal OpenGL states so that the target is ready for drawing. More...

## Protected Member Functions
| RenderTarget ()
| Default constructor. More...
void | initialize ()
| Performs the common initialization step after creation. More...

## Detailed Description

Base class for all render targets (window, texture, ...)

sf::RenderTarget defines the common behavior of all the 2D render targets usable in the graphics module.

It makes it possible to draw 2D entities like sprites, shapes, text without using any OpenGL command directly.

A sf::RenderTarget is also able to use views (sf::View), which are a kind of 2D cameras. With views you can globally scroll, rotate or zoom everything that is drawn, without having to transform every single entity. See the documentation of sf::View for more details and sample pieces of code about this class.

On top of that, render targets are still able to render direct OpenGL stuff. It is even possible to mix together OpenGL calls and regular SFML drawing commands. When doing so, make sure that OpenGL states are not messed up by calling the pushGLStates/popGLStates functions.

See also
  sf::RenderWindow, sf::RenderTexture, sf::View

Definition at line 52 of file RenderTarget.hpp.

## Constructor & Destructor Documentation

## ◆ ~RenderTarget()

virtual sf::RenderTarget::~RenderTarget | ( |  | ) |
| virtual

Destructor.

## ◆ RenderTarget()

sf::RenderTarget::RenderTarget | ( |  | ) |
| protected

Default constructor.

## Member Function Documentation

## ◆ clear()

void sf::RenderTarget::clear | ( | const Color & | color = `Color(0, 0, 0, 255)` | ) |

Clear the entire target with a single color.

This function is usually called once every frame, to clear the previous contents of the target.

Parameters

  color | Fill color to use to clear the render target

## ◆ draw() [1/4]

void sf::RenderTarget::draw | ( | const Drawable & | drawable,
|  | const RenderStates & | states = `RenderStates::Default`
| ) |  |

Draw a drawable object to the render target.

Parameters

  drawable | Object to draw
  states | Render states to use for drawing

## ◆ draw() [2/4]

void sf::RenderTarget::draw | ( | const Vertex * | vertices,
|  | std::size_t | vertexCount,
|  | PrimitiveType | type,
|  | const RenderStates & | states = `RenderStates::Default`
| ) |  |

Draw primitives defined by an array of vertices.

Parameters

  vertices | Pointer to the vertices
  vertexCount | Number of vertices in the array
  type | Type of primitives to draw
  states | Render states to use for drawing

## ◆ draw() [3/4]

void sf::RenderTarget::draw | ( | const VertexBuffer & | vertexBuffer,
|  | const RenderStates & | states = `RenderStates::Default`
| ) |  |

Draw primitives defined by a vertex buffer.

Parameters

  vertexBuffer | Vertex buffer
  states | Render states to use for drawing

## ◆ draw() [4/4]

void sf::RenderTarget::draw | ( | const VertexBuffer & | vertexBuffer,
|  | std::size_t | firstVertex,
|  | std::size_t | vertexCount,
|  | const RenderStates & | states = `RenderStates::Default`
| ) |  |

Draw primitives defined by a vertex buffer.

Parameters

  vertexBuffer | Vertex buffer
  firstVertex | Index of the first vertex to render
  vertexCount | Number of vertices to render
  states | Render states to use for drawing

## ◆ getDefaultView()

const View& sf::RenderTarget::getDefaultView | ( |  | ) | const

Get the default view of the render target.

The default view has the initial size of the render target, and never changes after the target has been created.

Returns
  The default view of the render target

See also
  setView, getView

## ◆ getSize()

virtual Vector2u sf::RenderTarget::getSize | ( |  | ) | const
| pure virtual

Return the size of the rendering region of the target.

Returns
  Size in pixels

Implemented in sf::RenderTexture, and sf::RenderWindow.

## ◆ getView()

const View& sf::RenderTarget::getView | ( |  | ) | const

Get the view currently in use in the render target.

Returns
  The view object that is currently used

See also
  setView, getDefaultView

## ◆ getViewport()

IntRect sf::RenderTarget::getViewport | ( | const View & | view | ) | const

Get the viewport of a view, applied to this render target.

The viewport is defined in the view as a ratio, this function simply applies this ratio to the current dimensions of the render target to calculate the pixels rectangle that the viewport actually covers in the target.

Parameters

  view | The view for which we want to compute the viewport

Returns
  Viewport rectangle, expressed in pixels

## ◆ initialize()

void sf::RenderTarget::initialize | ( |  | ) |
| protected

Performs the common initialization step after creation.

The derived classes must call this function after the target is created and ready for drawing.

## ◆ mapCoordsToPixel() [1/2]

Vector2i sf::RenderTarget::mapCoordsToPixel | ( | const Vector2f & | point | ) | const

Convert a point from world coordinates to target coordinates, using the current view.

This function is an overload of the mapCoordsToPixel function that implicitly uses the current view. It is equivalent to:

target.mapCoordsToPixel(point, target.getView());

Parameters

  point | Point to convert

Returns
  The converted point, in target coordinates (pixels)

See also
  mapPixelToCoords

## ◆ mapCoordsToPixel() [2/2]

Vector2i sf::RenderTarget::mapCoordsToPixel | ( | const Vector2f & | point,
|  | const View & | view
| ) |  | const

Convert a point from world coordinates to target coordinates.

This function finds the pixel of the render target that matches the given 2D point. In other words, it goes through the same process as the graphics card, to compute the final position of a rendered point.

Initially, both coordinate systems (world units and target pixels) match perfectly. But if you define a custom view or resize your render target, this assertion is not true anymore, i.e. a point located at (150, 75) in your 2D world may map to the pixel (10, 50) of your render target – if the view is translated by (140, 25).

This version uses a custom view for calculations, see the other overload of the function if you want to use the current view of the render target.

Parameters

  point | Point to convert
  view | The view to use for converting the point

Returns
  The converted point, in target coordinates (pixels)

See also
  mapPixelToCoords

## ◆ mapPixelToCoords() [1/2]

Vector2f sf::RenderTarget::mapPixelToCoords | ( | const Vector2i & | point | ) | const

Convert a point from target coordinates to world coordinates, using the current view.

This function is an overload of the mapPixelToCoords function that implicitly uses the current view. It is equivalent to:

target.mapPixelToCoords(point, target.getView());

Parameters

  point | Pixel to convert

Returns
  The converted point, in "world" coordinates

See also
  mapCoordsToPixel

## ◆ mapPixelToCoords() [2/2]

Vector2f sf::RenderTarget::mapPixelToCoords | ( | const Vector2i & | point,
|  | const View & | view
| ) |  | const

Convert a point from target coordinates to world coordinates.

This function finds the 2D position that matches the given pixel of the render target. In other words, it does the inverse of what the graphics card does, to find the initial position of a rendered pixel.

Initially, both coordinate systems (world units and target pixels) match perfectly. But if you define a custom view or resize your render target, this assertion is not true anymore, i.e. a point located at (10, 50) in your render target may map to the point (150, 75) in your 2D world – if the view is translated by (140, 25).

For render-windows, this function is typically used to find which point (or object) is located below the mouse cursor.

This version uses a custom view for calculations, see the other overload of the function if you want to use the current view of the render target.

Parameters

  point | Pixel to convert
  view | The view to use for converting the point

Returns
  The converted point, in "world" units

See also
  mapCoordsToPixel

## ◆ popGLStates()

void sf::RenderTarget::popGLStates | ( |  | ) |

Restore the previously saved OpenGL render states and matrices.

See the description of pushGLStates to get a detailed description of these functions.

See also
  pushGLStates

## ◆ pushGLStates()

void sf::RenderTarget::pushGLStates | ( |  | ) |

Save the current OpenGL render states and matrices.

This function can be used when you mix SFML drawing and direct OpenGL rendering. Combined with popGLStates, it ensures that:

- SFML's internal states are not messed up by your OpenGL code
- your OpenGL states are not modified by a call to a SFML function

More specifically, it must be used around code that calls Draw functions. Example:

// OpenGL code here...
window.pushGLStates();
window.draw(...);
window.draw(...);
window.popGLStates();
// OpenGL code here...

Note that this function is quite expensive: it saves all the possible OpenGL states and matrices, even the ones you don't care about. Therefore it should be used wisely. It is provided for convenience, but the best results will be achieved if you handle OpenGL states yourself (because you know which states have really changed, and need to be saved and restored). Take a look at the resetGLStates function if you do so.

See also
  popGLStates

## ◆ resetGLStates()

void sf::RenderTarget::resetGLStates | ( |  | ) |

Reset the internal OpenGL states so that the target is ready for drawing.

This function can be used when you mix SFML drawing and direct OpenGL rendering, if you choose not to use pushGLStates/popGLStates. It makes sure that all OpenGL states needed by SFML are set, so that subsequent draw() calls will work as expected.

Example:

// OpenGL code here...
glPushAttrib(...);
window.resetGLStates();
window.draw(...);
window.draw(...);
glPopAttrib(...);
// OpenGL code here...

## ◆ setActive()

virtual bool sf::RenderTarget::setActive | ( | bool | active = `true` | ) |
| virtual

Activate or deactivate the render target for rendering.

This function makes the render target's context current for future OpenGL rendering operations (so you shouldn't care about it if you're not doing direct OpenGL stuff). A render target's context is active only on the current thread, if you want to make it active on another thread you have to deactivate it on the previous thread first if it was active. Only one context can be current in a thread, so if you want to draw OpenGL geometry to another render target don't forget to activate it again. Activating a render target will automatically deactivate the previously active context (if any).

Parameters

  active | True to activate, false to deactivate

Returns
  True if operation was successful, false otherwise

Reimplemented in sf::RenderTexture, and sf::RenderWindow.

## ◆ setView()

void sf::RenderTarget::setView | ( | const View & | view | ) |

Change the current active view.

The view is like a 2D camera, it controls which part of the 2D scene is visible, and how it is viewed in the render target. The new view will affect everything that is drawn, until another view is set. The render target keeps its own copy of the view object, so it is not necessary to keep the original one alive after calling this function. To restore the original view of the target, you can pass the result of getDefaultView() to this function.

Parameters

  view | New view to use

See also
  getView, getDefaultView

The documentation for this class was generated from the following file:

- RenderTarget.hpp